import { Items, ItemStack, world } from "mojang-minecraft";
import { ActionFormData } from "mojang-minecraft-ui";
world.events.beforeItemUse.subscribe(data => {
    if (data.source.id !== 'minecraft:player')
        return;
    if (data.item.id === 'minecraft:barrier') {
        shopMenu(data.source);
    }
});
function shopMenu(player) {
    let form = new ActionFormData()
        form.title("Dev Settings")
        form.body("")
        form.button("Plants")
        form.button("Reset Achievements")
        form.button("Reset Quests")
        form.button("Get Achievements")
        form.button("Credits")
        form.show(player).then((response) => {
        if (response.selection === 1) {
             player.runCommand("function reset_Achievements");
    }
        if (response.selection === 2) {
             player.runCommand("function reset_Quests");
    }
        if (response.selection === 3) {
             player.runCommand("function get_Achievements");
    }
        if (response.selection === 4) {
             player.runCommand("[]")
    }
        if (response.selection === 0) return shopGui(player)
        })
    }
const shopItems = [{
        name: 'Sunflower §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:sunflower_packet'))
    }, {
        name: 'Peashooter §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:peashooter_packet'))
    }, {
        name: 'Wallnut §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:wallnut_packet'))
    }, {
        name: 'Potato Mine §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:potato_mine_packet'))
    }, {
        name: 'Cabbage Pult §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:cabbage_pult_packet'))
    }, {
        name: 'Bloomerang §a$175',
        cost: 175,
        item: new ItemStack(Items.get('pvz:bloomerang_packet'))
    }, {
        name: 'Iceberg Lettuce §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:iceberg_lettuce_packet'))
    }, {
        name: 'Gravebuster §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:gravebuster'))
    }, {
        name: 'Bonk Choy §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:bonk_choy_packet'))
    }, {
        name: 'Repeater §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:repeater_packet'))
    }, {
        name: 'Twin Sunflower §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:twin_sunflower_packet'))
    }, {
        name: 'Kernel Pult §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:kernel_pult_packet'))
    }, {
        name: 'Snapdragon §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:snapdragon_packet'))
    }, {
        name: 'Spikeweed §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:spikeweed_packet'))
    }, {
        name: 'Coconut Cannon §a$400',
        cost: 400,
        item: new ItemStack(Items.get('pvz:coconut_cannon_packet'))
    }, {
        name: 'Threepeater §a$325',
        cost: 325,
        item: new ItemStack(Items.get('pvz:threepeater_packet'))
    }, {
        name: 'Spikerock §a$225',
        cost: 225,
        item: new ItemStack(Items.get('pvz:spikerock_packet'))
    }, {
        name: 'Cherrybomb §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:cherrybomb_packet'))
    }, {
        name: 'Peapod §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:peapod_packet'))
    }, {
        name: 'Lightning Reed §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:lightning_reed_packet'))
    }, {
        name: 'Melon Pult §a$300',
        cost: 300,
        item: new ItemStack(Items.get('pvz:melon_pult_packet'))
    }, {
        name: 'Tallnut §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:tallnut_packet'))
    }, {
        name: 'Winter Melon §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:winter_melon_packet'))
    }, {
        name: 'Pepper Pult §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:pepper_pult_packet'))
    }, {
        name: 'Endurian §a$135',
        cost: 135,
        item: new ItemStack(Items.get('pvz:endurian_packet'))
    }, {
        name: 'Blover §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:blover_packet'))
    }, {
        name: 'Citron §a$350',
        cost: 350,
        item: new ItemStack(Items.get('pvz:citron_packet'))
    }, {
        name: 'Infinut §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:infinut_packet'))
    }, {
        name: 'Sunshroom §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:sunshroom_packet'))
    }, {
        name: 'Puffshroom §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:puffshroom_packet'))
    }, {
        name: 'Fumeshroom §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:fumeshroom_packet'))
    }, {
        name: 'Scaredyshroom §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:scaredyshroom_packet'))
    }, {
        name: 'Magnet Shroom §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:magnet_shroom_packet'))
    }, {
        name: 'Gold Magnetshroom §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:gold_magnet_packet'))
    }, {
        name: 'Plantern §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:plantern_packet'))
    }, {
        name: 'Iceshroom §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:iceshroom_packet'))
    }, {
        name: 'Phatbeet §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:phatbeet_packet'))
    }, {
        name: 'Electric Blueberry §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:electric_blueberry_packet'))
    }, {
        name: 'Lily Pad §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:lilypad_packet'))
    }, {
        name: 'Tangle Kelp §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:tangle_kelp_packet'))
    }, {
        name: 'Guacodile §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:guacodile_packet'))
    }, {
        name: 'Banana Launcher §a$500',
        cost: 500,
        item: new ItemStack(Items.get('pvz:banana_launcher_packet'))
    }, {
        name: 'Cob Cannon §a$500',
        cost: 500,
        item: new ItemStack(Items.get('pvz:cob_cannon_packet'))
    }, {
        name: 'Seashroom §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:seashroom_packet'))
    }, {
        name: 'Moonflower §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:moonflower_packet'))
    }, {
        name: 'Nightshade §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:nightshade_packet'))
    }, {
        name: 'Shadowshroom §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:shadowshroom_packet'))
    }, {
        name: 'Dusklobber §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:dusklobber_packet'))
    }, {
        name: 'Marigold §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:marigold_packet'))
    }, {
        name: 'Doomshroom §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:doomshroom_packet'))
    }, {
        name: 'Snow Peashooter §a$175',
        cost: 175,
        item: new ItemStack(Items.get('pvz:snow_peashooter_packet'))
    }, {
        name: 'Squash §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:squash_packet'))
    }, {
        name: 'Jalapeno §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:jalapeno_packet'))
    }, {
        name: 'Hypnoshroom §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:hypnoshroom_packet'))
    }, {
        name: 'Peanut §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:peanut_packet'))
    }, {
        name: 'Chomper §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:chomper_packet'))
    }, {
        name: 'Lava Guava §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:lava_guava_packet'))
    }, {
        name: 'Toadstool §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:toadstool_packet'))
    }, {
        name: 'Fire Peashooter §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:fire_peashooter_packet'))
    }, {
        name: 'Cactus §a$175',
        cost: 175,
        item: new ItemStack(Items.get('pvz:cactus_packet'))
    }, {
        name: 'Cold Snapdragon §a$250',
        cost: 250,
        item: new ItemStack(Items.get('pvz:cold_snapdragon_packet'))
    }, {
        name: 'Wasabi Whip §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:wasabi_whip_packet'))
    }, {
        name: 'Apple Mortar §a$250',
        cost: 250,
        item: new ItemStack(Items.get('pvz:apple_mortar_packet'))
    }, {
        name: 'Electric Peashooter §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:electric_peashooter_packet'))
    }, {
        name: 'Gatling Peashooter §a$250',
        cost: 250,
        item: new ItemStack(Items.get('pvz:gatling_peashooter_packet'))
    }, {
        name: 'Torchwood §a$175',
        cost: 175,
        item: new ItemStack(Items.get('pvz:torchwood_packet'))
    }, {
        name: 'Starfruit §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:starfruit_packet'))
    }, {
        name: 'Explode O Nut §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:explode_o_nut_packet'))
    }, {
        name: 'Aloe §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:aloe_packet'))
    }, {
        name: 'Shadow Peashooter §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:shadow_peashooter_packet'))
    }, {
        name: 'Goo Peashooter §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:goo_peashooter_packet'))
    }, {
        name: 'Snap Pea §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:snappea_packet'))
    }, {
        name: 'Puffball §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:puffball_packet'))
    }, {
        name: 'Cattail §a$225',
        cost: 225,
        item: new ItemStack(Items.get('pvz:cattail_packet'))
    }, {
        name: 'Pumpkin Witch§a$250',
        cost: 250,
        item: new ItemStack(Items.get('pvz:pumpkin_witch_packet'))
    }, {
        name: 'button76',
        cost: 50,
        item: new ItemStack(Items.get('minecraft:diamond'))
    }, {
        name: 'button77',
        cost: 50,
        item: new ItemStack(Items.get('minecraft:diamond'))
    }, {
        name: 'button78',
        cost: 50,
        item: new ItemStack(Items.get('minecraft:diamond'))
    }, {
        name: 'button79',
        cost: 50,
        item: new ItemStack(Items.get('minecraft:diamond'))
    }, {
        name: 'button80',
        cost: 50,
        item: new ItemStack(Items.get('minecraft:diamond'))
    }];
function shopGui(player) {
    let gui = new ActionFormData();
    gui.title(`Shop`);
    gui.body('Choose your plants (wip)');
    gui.button("Sunflower §a$50", "textures/plants_spawn/sunflower");
    gui.button("Peashooter §a$100", "textures/plants_spawn/peashooter");
    gui.button("Wallnut §a$50", "textures/plants_spawn/wallnut");
    gui.button("Potato Mine §a$25", "textures/plants_spawn/potato_mine");
    gui.button("Cabbage Pult §a$100", "textures/plants_spawn/cabbage_pult");
    gui.button("Bloomerang §a$175", "textures/plants_spawn/bloomerang");
    gui.button("Iceberg Lettuce §a$0", "textures/plants_spawn/iceberg_lettuce");
    gui.button("Gravebuster §a$0", "textures/plants_spawn/gravebuster_2");
    gui.button("Bonk Choy §a$150", "textures/plants_spawn/bonk_choy");
    gui.button("Repeater §a$200", "textures/plants_spawn/repeater");
    gui.button("Twin Sunflower §a$125", "textures/plants_spawn/twin_sunflower");
    gui.button("Kernel Pult §a$100", "textures/plants_spawn/kernel_pult");
    gui.button("Snapdragon §a$50", "textures/plants_spawn/snapdragon");
    gui.button("Spikeweed §a$100", "textures/plants_spawn/spikeweed");
    gui.button("Coconut Cannon §a$400", "textures/plants_spawn/coconut_cannon");
    gui.button("Threepeater §a$325", "textures/plants_spawn/threepeater");
    gui.button("Spikerock §a$225", "textures/plants_spawn/spikerock");
    gui.button("Cherrybomb §a$150", "textures/plants_spawn/cherrybomb");
    gui.button("Peapod §a$125", "textures/plants_spawn/peapod");
    gui.button("Lightning Reed §a$125", "textures/plants_spawn/lightning_reed");
    gui.button("Melon Pult §a$300", "textures/plants_spawn/melon_pult");
    gui.button("Tallnut §a$125", "textures/plants_spawn/tallnut");
    gui.button("Winter Melon §a$200", "textures/plants_spawn/winter_melon");
    gui.button("Pepper Pult §a$200", "textures/plants_spawn/pepper_pult");
    gui.button("Endrurian §a$135", "textures/plants_spawn/endurian");
    gui.button("Blover §a$50", "textures/plants_spawn/blover");
    gui.button("Citron §a$350", "textures/plants_spawn/citron");
    gui.button("Infinut §a$75", "textures/plants_spawn/infinut");
    gui.button("Sunshroom §a$25", "textures/plants_spawn/sunshroom");
    gui.button("Puffshroom §a$0", "textures/plants_spawn/puffshroom");
    gui.button("Fumeshroom §a$125", "textures/plants_spawn/fumeshroom");
    gui.button("Scaredyshroom §a$25", "textures/plants_spawn/scaredyshroom");
    gui.button("Magnetshroom §a$100", "textures/plants_spawn/magnet_shroom");
    gui.button("Gold Magnetshroom §a$200", "textures/plants_spawn/gold_magnet");
    gui.button("Plantern §a$25", "textures/plants_spawn/plantern");
    gui.button("Iceshroom §a$75", "textures/plants_spawn/ice");
    gui.button("Phatbeet §a$150", "textures/plants_spawn/phatbeet");
    gui.button("Electric Blueberry §a$150", "textures/plants_spawn/electric_blueberry");
    gui.button("Lilypad §a$25", "textures/plants_spawn/lilypad");
    gui.button("Tangle Kelp §a$25", "textures/plants_spawn/tangle_kelp");
    gui.button("Guacodile §a$125", "textures/plants_spawn/guacodile");
    gui.button("Banana Launcher §a$500", "textures/plants_spawn/banana_launcher");
    gui.button("Cob Cannon §a$500", "textures/plants_spawn/cob_cannon");
    gui.button("Seashroom §a$0", "textures/plants_spawn/seashroom");
    gui.button("Moonflower §a$50", "textures/plants_spawn/moonflower");
    gui.button("Nightshade §a$75", "textures/plants_spawn/nightshade");
    gui.button("Shadowshroom §a$50", "textures/plants_spawn/shadowshroom");
    gui.button("Dusklobber §a$150", "textures/plants_spawn/dusklobber");
    gui.button("Marigold §a$50", "textures/plants_spawn/marigold");
    gui.button("Doomshroom §a$200", "textures/plants_spawn/doomshroom");
    gui.button("Snow Peashooter §a$175", "textures/plants_spawn/snow_peashooter");
    gui.button("Squash §a$50", "textures/plants_spawn/squash");
    gui.button("Jalapeno §a$125", "textures/plants_spawn/jalapeno");
    gui.button("Hypnoshroom §a$125", "textures/plants_spawn/hypnoshroom");
    gui.button("Peanut §a$150", "textures/plants_spawn/peanut");
    gui.button("Chomper §a$150", "textures/plants_spawn/chomper");
    gui.button("Lava Guava §a$75", "textures/plants_spawn/lava_guava");
    gui.button("Toadstool §a$200", "textures/plants_spawn/toadstool");
    gui.button("Fire Peashooter §a$125", "textures/plants_spawn/fire_peashooter");
    gui.button("Cactus §a$175", "textures/plants_spawn/cactus");
    gui.button("Cold Snapdragon §a$250", "textures/plants_spawn/cold_snapdragon");
    gui.button("Wasabi Whip §a$150", "textures/plants_spawn/wasabi");
    gui.button("Apple Mortar §a$250", "textures/plants_spawn/apple_mortar");
    gui.button("Electric Peashooter §a$200", "textures/plants_spawn/electric_peashooter");
    gui.button("Gatling Peashooter §a$250", "textures/plants_spawn/gatling_peashooter");
    gui.button("Torchwood §a$175", "textures/plants_spawn/torchwood");
    gui.button("Starfruit §a$150", "textures/plants_spawn/starfruit");
    gui.button("Explode O Nut §a$50", "textures/plants_spawn/explode_o_nut");
    gui.button("Aloe §a$75", "textures/plants_spawn/aloe");
    gui.button("Shadow Peashooter §a$125", "textures/plants_spawn/shadow_peashooter");
    gui.button("Goo Peashooter §a$125", "textures/plants_spawn/goo_peashooter");
    gui.button("Snap Pea §a$200", "textures/plants_spawn/snappea");
    gui.button("Puffball §a$150", "textures/plants_spawn/puffball");
    gui.button("Cattail §a$225", "textures/plants_spawn/cattail");
    gui.button("Pumpkin Witch §a$250", "textures/plants_spawn/pumpkin_witch");
    gui.button("button76", "textures/plants_spawn/");
    gui.button("button77", "textures/plants_spawn/");
    gui.button("button78", "textures/plants_spawn/");
    gui.button("button79", "textures/plants_spawn/");
    gui.button("button80", "textures/plants_spawn/");
    gui.show(player).then(result => { 
        if (result.isCancelled)
            return
        const money = getScore('Sun', player, true);
        const item = shopItems[result.selection];
        if (money < item.cost) {
            messagePlayer(player, `§cYou don't have enough sun to purchase that!`)
            return
        }
        messagePlayer(player, `§2You have purchased §a${item.name}`);
        player.runCommand(`scoreboard players remove @s Sun ${item.cost}`);
        player.getComponent('inventory').container.addItem(item.item);
    });
};
/**
 * Get the score of a target on an objective
 * @param {string} objective Objective to get a score from
 * @param {Entity|string} target The entity, player, or fake player to get the score of
 * @param {boolean} useZero Specifies whether to return NaN or 0 if an error is thrown
 * @returns {number} The target's score, or NaN / 0 if error
 */
const getScore = (objective, target, useZero = false) => {
    try {
        const obj = world.scoreboard.getObjective(objective);
        if (typeof target == 'string')
            return obj.getScore(obj.getParticipants().find(v => v.displayName == target));
        return obj.getScore(target.scoreboard);
    }
    catch {
        return useZero ? 0 : NaN;
    }
};
/**
 * Send a message to a player
 * @param {Player} player Player to message
 * @param {string} message Message to send to the player
 */
const messagePlayer = (player, message) => {
    player.runCommand(`tellraw @s {"rawtext":[{"text":"${message}"}]}`);
};
